diff --git a/src/backend/access/transam/multixact.c b/src/backend/access/transam/multixact.c
index 0a719befc4..c156335852 100644
--- a/src/backend/access/transam/multixact.c
+++ b/src/backend/access/transam/multixact.c
@@ -495,9 +495,8 @@ MultiXactIdExpand(MultiXactId multi, TransactionId xid, MultiXactStatus status)
 	/* MultiXactIdSetOldestMember() must have been called already. */
 	Assert(MultiXactIdIsValid(GetOldestMemberMXactId(MyProcNumber)));
 
-	debug_elog5(DEBUG2, "Expand: received multi %llu, xid %llu status %s",
-				(unsigned long long) multi, (unsigned long long) xid,
-				mxstatus_to_string(status));
+	debug_elog5(DEBUG2, "Expand: received multi %" PRIu64 ", xid %" PRIu64 " status %s",
+				multi, xid, mxstatus_to_string(status));
 
 	/*
 	 * Note: we don't allow for old multis here.  The reason is that the only
@@ -521,8 +520,8 @@ MultiXactIdExpand(MultiXactId multi, TransactionId xid, MultiXactStatus status)
 		member.status = status;
 		newMulti = MultiXactIdCreateFromMembers(1, &member);
 
-		debug_elog4(DEBUG2, "Expand: %llu has no members, create singleton %llu",
-					(unsigned long long) multi, (unsigned long long) newMulti);
+		debug_elog4(DEBUG2, "Expand: %" PRIu64 " has no members, create singleton %" PRIu64,
+					multi, newMulti);
 		return newMulti;
 	}
 
@@ -535,8 +534,8 @@ MultiXactIdExpand(MultiXactId multi, TransactionId xid, MultiXactStatus status)
 		if (TransactionIdEquals(members[i].xid, xid) &&
 			(members[i].status == status))
 		{
-			debug_elog4(DEBUG2, "Expand: %llu is already a member of %llu",
-						(unsigned long long) xid, (unsigned long long) multi);
+			debug_elog4(DEBUG2, "Expand: %" PRIu64 " is already a member of %" PRIu64,
+						xid, multi);
 			pfree(members);
 			return multi;
 		}
@@ -576,8 +575,8 @@ MultiXactIdExpand(MultiXactId multi, TransactionId xid, MultiXactStatus status)
 	pfree(members);
 	pfree(newMembers);
 
-	debug_elog3(DEBUG2, "Expand: returning new multi %llu",
-				(unsigned long long) newMulti);
+	debug_elog3(DEBUG2, "Expand: returning new multi %" PRIu64,
+				newMulti);
 
 	return newMulti;
 }
@@ -600,7 +599,7 @@ MultiXactIdIsRunning(MultiXactId multi, bool isLockOnly)
 	int			nmembers;
 	int			i;
 
-	debug_elog3(DEBUG2, "IsRunning %llu?", (unsigned long long) multi);
+	debug_elog3(DEBUG2, "IsRunning %" PRIu64 "?", multi);
 
 	/*
 	 * "false" here means we assume our callers have checked that the given
@@ -640,8 +639,8 @@ MultiXactIdIsRunning(MultiXactId multi, bool isLockOnly)
 	{
 		if (TransactionIdIsInProgress(members[i].xid))
 		{
-			debug_elog4(DEBUG2, "IsRunning: member %d (%llu) is running", i,
-						(unsigned long long) members[i].xid);
+			debug_elog4(DEBUG2, "IsRunning: member %d (%" PRIu64 ") is running",
+						i, members[i].xid);
 			pfree(members);
 			return true;
 		}
@@ -649,8 +648,8 @@ MultiXactIdIsRunning(MultiXactId multi, bool isLockOnly)
 
 	pfree(members);
 
-	debug_elog3(DEBUG2, "IsRunning: %llu is not running",
-				(unsigned long long) multi);
+	debug_elog3(DEBUG2, "IsRunning: %" PRIu64 " is not running",
+				multi);
 
 	return false;
 }
@@ -704,8 +703,8 @@ MultiXactIdSetOldestMember(void)
 
 		LWLockRelease(MultiXactGenLock);
 
-		debug_elog4(DEBUG2, "MultiXact: setting OldestMember[%d] = %llu",
-					MyProcNumber, (unsigned long long) nextMXact);
+		debug_elog4(DEBUG2, "MultiXact: setting OldestMember[%d] = %" PRIu64,
+					MyProcNumber, nextMXact);
 	}
 }
 
@@ -757,8 +756,8 @@ MultiXactIdSetOldestVisible(void)
 
 		LWLockRelease(MultiXactGenLock);
 
-		debug_elog4(DEBUG2, "MultiXact: setting OldestVisible[%d] = %llu",
-					MyProcNumber, (unsigned long long) oldestMXact);
+		debug_elog4(DEBUG2, "MultiXact: setting OldestVisible[%d] = %" PRIu64,
+					MyProcNumber, oldestMXact);
 	}
 }
 
@@ -1132,8 +1131,8 @@ GetNewMultiXactId(int nmembers, MultiXactOffset *offset)
 
 	LWLockRelease(MultiXactGenLock);
 
-	debug_elog4(DEBUG2, "GetNew: returning %llu offset %llu",
-				(unsigned long long) result, (unsigned long long) *offset);
+	debug_elog4(DEBUG2, "GetNew: returning %" PRIu64 " offset %" PRIu64,
+				result, *offset);
 	return result;
 }
 
@@ -1184,8 +1183,8 @@ GetMultiXactIdMembers(MultiXactId multi, MultiXactMember **members,
 	LWLock	   *lock;
 	bool		slept = false;
 
-	debug_elog3(DEBUG2, "GetMembers: asked for %llu",
-				(unsigned long long) multi);
+	debug_elog3(DEBUG2, "GetMembers: asked for %" PRIu64,
+				multi);
 
 	if (!MultiXactIdIsValid(multi) || from_pgupgrade)
 	{
@@ -1244,14 +1243,14 @@ GetMultiXactIdMembers(MultiXactId multi, MultiXactMember **members,
 	if (MultiXactIdPrecedes(multi, oldestMXact))
 		ereport(ERROR,
 				(errcode(ERRCODE_INTERNAL_ERROR),
-				 errmsg("MultiXactId %llu does no longer exist -- apparent wraparound",
-						(unsigned long long) multi)));
+				 errmsg("MultiXactId %" PRIu64 " does no longer exist -- apparent wraparound",
+						multi)));
 
 	if (!MultiXactIdPrecedes(multi, nextMXact))
 		ereport(ERROR,
 				(errcode(ERRCODE_INTERNAL_ERROR),
-				 errmsg("MultiXactId %llu has not been created yet -- apparent wraparound",
-						(unsigned long long) multi)));
+				 errmsg("MultiXactId %" PRIu64 " has not been created yet -- apparent wraparound",
+						multi)));
 
 	/*
 	 * Find out the offset at which we need to start reading MultiXactMembers
@@ -1303,8 +1302,8 @@ retry:
 
 	if (offset == 0)
 		ereport(ERROR,
-				(errmsg("found invalid zero offset in multixact %llu",
-						(unsigned long long) multi)));
+				(errmsg("found invalid zero offset in multixact %" PRIu64,
+						multi)));
 
 	/*
 	 * Use the same increment rule as GetNewMultiXactId(), that is, don't
@@ -1513,8 +1512,8 @@ mXactCacheGetBySet(int nmembers, MultiXactMember *members)
 		 */
 		if (memcmp(members, entry->members, nmembers * sizeof(MultiXactMember)) == 0)
 		{
-			debug_elog3(DEBUG2, "CacheGet: found %llu",
-						(unsigned long long) entry->multi);
+			debug_elog3(DEBUG2, "CacheGet: found %" PRIu64,
+						entry->multi);
 			dclist_move_head(&MXactCache, iter.cur);
 			return entry->multi;
 		}
@@ -1537,8 +1536,8 @@ mXactCacheGetById(MultiXactId multi, MultiXactMember **members)
 {
 	dlist_iter	iter;
 
-	debug_elog3(DEBUG2, "CacheGet: looking for %llu",
-				(unsigned long long) multi);
+	debug_elog3(DEBUG2, "CacheGet: looking for %" PRIu64,
+				multi);
 
 	dclist_foreach(iter, &MXactCache)
 	{
@@ -1618,8 +1617,8 @@ mXactCachePut(MultiXactId multi, int nmembers, MultiXactMember *members)
 		dclist_delete_from(&MXactCache, node);
 
 		entry = dclist_container(mXactCacheEnt, node, node);
-		debug_elog3(DEBUG2, "CachePut: pruning cached multi %llu",
-					(unsigned long long) entry->multi);
+		debug_elog3(DEBUG2, "CachePut: pruning cached multi %" PRIu64,
+					entry->multi);
 
 		pfree(entry);
 	}
@@ -1660,13 +1659,12 @@ mxid_to_string(MultiXactId multi, int nmembers, MultiXactMember *members)
 
 	initStringInfo(&buf);
 
-	appendStringInfo(&buf, "%llu %d[%llu (%s)", (unsigned long long) multi,
-					 nmembers, (unsigned long long) members[0].xid,
-					 mxstatus_to_string(members[0].status));
+	appendStringInfo(&buf, "%" PRIu64 " %d[%" PRIu64 " (%s)", multi, nmembers,
+					 members[0].xid, mxstatus_to_string(members[0].status));
 
 	for (i = 1; i < nmembers; i++)
-		appendStringInfo(&buf, ", %llu (%s)",
-						 (unsigned long long) members[i].xid,
+		appendStringInfo(&buf, ", %" PRIu64 " (%s)",
+						 members[i].xid,
 						 mxstatus_to_string(members[i].status));
 
 	appendStringInfoChar(&buf, ']');
@@ -2223,10 +2221,8 @@ MultiXactGetCheckptMulti(bool is_shutdown,
 	LWLockRelease(MultiXactGenLock);
 
 	debug_elog6(DEBUG2,
-				"MultiXact: checkpoint is nextMulti %llu, nextOffset %llu, oldestMulti %llu in DB %u",
-				(unsigned long long) *nextMulti,
-				(unsigned long long) *nextMultiOffset,
-				(unsigned long long) *oldestMulti, *oldestMultiDB);
+				"MultiXact: checkpoint is nextMulti %" PRIu64 ", nextOffset %" PRIu64 ", oldestMulti %" PRIu64 " in DB %u",
+				*nextMulti, *nextMultiOffset, *oldestMulti, *oldestMultiDB);
 }
 
 /*
@@ -2260,9 +2256,8 @@ void
 MultiXactSetNextMXact(MultiXactId nextMulti,
 					  MultiXactOffset nextMultiOffset)
 {
-	debug_elog4(DEBUG2, "MultiXact: setting next multi to %llu offset %llu",
-				(unsigned long long) nextMulti,
-				(unsigned long long) nextMultiOffset);
+	debug_elog4(DEBUG2, "MultiXact: setting next multi to %" PRIu64 " offset %" PRIu64,
+				nextMulti, nextMultiOffset);
 	LWLockAcquire(MultiXactGenLock, LW_EXCLUSIVE);
 	MultiXactState->nextMXact = nextMulti;
 	MultiXactState->nextOffset = nextMultiOffset;
@@ -2345,14 +2340,14 @@ MultiXactAdvanceNextMXact(MultiXactId minMulti,
 	LWLockAcquire(MultiXactGenLock, LW_EXCLUSIVE);
 	if (MultiXactIdPrecedes(MultiXactState->nextMXact, minMulti))
 	{
-		debug_elog3(DEBUG2, "MultiXact: setting next multi to %llu",
-					(unsigned long long) minMulti);
+		debug_elog3(DEBUG2, "MultiXact: setting next multi to %" PRIu64,
+					minMulti);
 		MultiXactState->nextMXact = minMulti;
 	}
 	if (MultiXactOffsetPrecedes(MultiXactState->nextOffset, minMultiOffset))
 	{
-		debug_elog3(DEBUG2, "MultiXact: setting next offset to %llu",
-					(unsigned long long) minMultiOffset);
+		debug_elog3(DEBUG2, "MultiXact: setting next offset to %" PRIu64,
+					minMultiOffset);
 		MultiXactState->nextOffset = minMultiOffset;
 	}
 	LWLockRelease(MultiXactGenLock);
@@ -2725,9 +2720,8 @@ TruncateMultiXact(MultiXactId newOldestMulti, Oid newOldestMultiDB)
 	else if (!find_multixact_start(oldestMulti, &oldestOffset))
 	{
 		ereport(LOG,
-				(errmsg("oldest MultiXact %llu not found, earliest MultiXact %llu, skipping truncation",
-						(unsigned long long) oldestMulti,
-						(unsigned long long) earliest)));
+				(errmsg("oldest MultiXact %" PRIu64 " not found, earliest MultiXact %" PRIu64 ", skipping truncation",
+						oldestMulti, earliest)));
 		LWLockRelease(MultiXactTruncationLock);
 		return;
 	}
@@ -2744,19 +2738,19 @@ TruncateMultiXact(MultiXactId newOldestMulti, Oid newOldestMultiDB)
 	else if (!find_multixact_start(newOldestMulti, &newOldestOffset))
 	{
 		ereport(LOG,
-				(errmsg("cannot truncate up to MultiXact %llu because it does not exist on disk, skipping truncation",
-						(unsigned long long) newOldestMulti)));
+				(errmsg("cannot truncate up to MultiXact %" PRIu64 " because it does not exist on disk, skipping truncation",
+						newOldestMulti)));
 		LWLockRelease(MultiXactTruncationLock);
 		return;
 	}
 
 	elog(DEBUG1, "performing multixact truncation: "
-		 "offsets [%llu, %llu), offsets segments [%" PRIx64 ", %" PRIx64 "), "
-		 "members [%llu, %llu), members segments [%" PRIx64 ", %" PRIx64 ")",
-		 (unsigned long long) oldestMulti, (unsigned long long) newOldestMulti,
+		 "offsets [%" PRIu64 ", %" PRIu64 "), offsets segments [%" PRIx64 ", %" PRIx64 "), "
+		 "members [%" PRIu64 ", %" PRIu64 "), members segments [%" PRIx64 ", %" PRIx64 ")",
+		 oldestMulti, newOldestMulti,
 		 MultiXactIdToOffsetSegment(oldestMulti),
 		 MultiXactIdToOffsetSegment(newOldestMulti),
-		 (long long) oldestOffset, (long long) newOldestOffset,
+		 oldestOffset, newOldestOffset,
 		 MXOffsetToMemberSegment(oldestOffset),
 		 MXOffsetToMemberSegment(newOldestOffset));
 
@@ -3011,14 +3005,14 @@ multixact_redo(XLogReaderState *record)
 			   SizeOfMultiXactTruncate);
 
 		elog(DEBUG1, "replaying multixact truncation: "
-			 "offsets [%llu, %llu), offsets segments [%" PRIx64 ", %" PRIx64 "), "
-			 "members [%llu, %llu), members segments [%" PRIx64 ", %" PRIx64 ")",
-			 (unsigned long long) xlrec.startTruncOff,
-			 (unsigned long long) xlrec.endTruncOff,
+			 "offsets [%" PRIu64 ", %" PRIu64 "), offsets segments [%" PRIx64 ", %" PRIx64 "), "
+			 "members [%" PRIu64 ", %" PRIu64 "), members segments [%" PRIx64 ", %" PRIx64 ")",
+			 xlrec.startTruncOff,
+			 xlrec.endTruncOff,
 			 MultiXactIdToOffsetSegment(xlrec.startTruncOff),
 			 MultiXactIdToOffsetSegment(xlrec.endTruncOff),
-			 (unsigned long long) xlrec.startTruncMemb,
-			 (unsigned long long) xlrec.endTruncMemb,
+			 xlrec.startTruncMemb,
+			 xlrec.endTruncMemb,
 			 MXOffsetToMemberSegment(xlrec.startTruncMemb),
 			 MXOffsetToMemberSegment(xlrec.endTruncMemb));
 
@@ -3065,8 +3059,8 @@ pg_get_multixact_members(PG_FUNCTION_ARGS)
 	if (mxid < FirstMultiXactId)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
-				 errmsg("invalid MultiXactId: %llu",
-						(unsigned long long) mxid)));
+				 errmsg("invalid MultiXactId: %" PRIu64,
+						mxid)));
 
 	if (SRF_IS_FIRSTCALL())
 	{
@@ -3099,8 +3093,7 @@ pg_get_multixact_members(PG_FUNCTION_ARGS)
 		HeapTuple	tuple;
 		char	   *values[2];
 
-		values[0] = psprintf("%llu",
-							 (unsigned long long) multi->members[multi->iter].xid);
+		values[0] = psprintf("%" PRIu64, multi->members[multi->iter].xid);
 		values[1] = mxstatus_to_string(multi->members[multi->iter].status);
 
 		tuple = BuildTupleFromCStrings(funccxt->attinmeta, values);
diff --git a/src/backend/access/transam/slru.c b/src/backend/access/transam/slru.c
index 75fb991b3c..d679f64b20 100644
--- a/src/backend/access/transam/slru.c
+++ b/src/backend/access/transam/slru.c
@@ -1058,15 +1058,15 @@ SlruReportIOError(SlruCtl ctl, int64 pageno, TransactionId xid)
 		case SLRU_OPEN_FAILED:
 			ereport(ERROR,
 					(errcode_for_file_access(),
-					 errmsg("could not access status of transaction %llu",
-							(unsigned long long) xid),
+					 errmsg("could not access status of transaction %" PRIu64,
+							xid),
 					 errdetail("Could not open file \"%s\": %m.", path)));
 			break;
 		case SLRU_SEEK_FAILED:
 			ereport(ERROR,
 					(errcode_for_file_access(),
-					 errmsg("could not access status of transaction %llu",
-							(unsigned long long) xid),
+					 errmsg("could not access status of transaction %" PRIu64,
+							xid),
 					 errdetail("Could not seek in file \"%s\" to offset %d: %m.",
 							   path, offset)));
 			break;
@@ -1074,14 +1074,14 @@ SlruReportIOError(SlruCtl ctl, int64 pageno, TransactionId xid)
 			if (errno)
 				ereport(ERROR,
 						(errcode_for_file_access(),
-						 errmsg("could not access status of transaction %llu",
-								(unsigned long long) xid),
+						 errmsg("could not access status of transaction %" PRIu64,
+								xid),
 						 errdetail("Could not read from file \"%s\" at offset %d: %m.",
 								   path, offset)));
 			else
 				ereport(ERROR,
-						(errmsg("could not access status of transaction %llu",
-								(unsigned long long) xid),
+						(errmsg("could not access status of transaction %" PRIu64,
+								xid),
 						 errdetail("Could not read from file \"%s\" at offset %d: read too few bytes.",
 								   path, offset)));
 			break;
@@ -1089,30 +1089,30 @@ SlruReportIOError(SlruCtl ctl, int64 pageno, TransactionId xid)
 			if (errno)
 				ereport(ERROR,
 						(errcode_for_file_access(),
-						 errmsg("could not access status of transaction %llu",
-								(unsigned long long) xid),
+						 errmsg("could not access status of transaction %" PRIu64,
+								xid),
 						 errdetail("Could not write to file \"%s\" at offset %d: %m.",
 								   path, offset)));
 			else
 				ereport(ERROR,
-						(errmsg("could not access status of transaction %llu",
-								(unsigned long long) xid),
+						(errmsg("could not access status of transaction %" PRIu64,
+								xid),
 						 errdetail("Could not write to file \"%s\" at offset %d: wrote too few bytes.",
 								   path, offset)));
 			break;
 		case SLRU_FSYNC_FAILED:
 			ereport(data_sync_elevel(ERROR),
 					(errcode_for_file_access(),
-					 errmsg("could not access status of transaction %llu",
-							(unsigned long long) xid),
+					 errmsg("could not access status of transaction %" PRIu64,
+							xid),
 					 errdetail("Could not fsync file \"%s\": %m.",
 							   path)));
 			break;
 		case SLRU_CLOSE_FAILED:
 			ereport(ERROR,
 					(errcode_for_file_access(),
-					 errmsg("could not access status of transaction %llu",
-							(unsigned long long) xid),
+					 errmsg("could not access status of transaction %" PRIu64,
+							xid),
 					 errdetail("Could not close file \"%s\": %m.",
 							   path)));
 			break;
diff --git a/src/backend/access/transam/subtrans.c b/src/backend/access/transam/subtrans.c
index 7b3639c208..a03b79e536 100644
--- a/src/backend/access/transam/subtrans.c
+++ b/src/backend/access/transam/subtrans.c
@@ -181,9 +181,8 @@ SubTransGetTopmostTransaction(TransactionId xid)
 		 * structure that could lead to an infinite loop, so exit.
 		 */
 		if (!TransactionIdPrecedes(parentXid, previousXid))
-			elog(ERROR, "pg_subtrans contains invalid entry: xid %llu points to parent xid %llu",
-				 (unsigned long long) previousXid,
-				 (unsigned long long) parentXid);
+			elog(ERROR, "pg_subtrans contains invalid entry: xid %" PRIu64 " points to parent xid %" PRIu64,
+				 previousXid, parentXid);
 	}
 
 	Assert(TransactionIdIsValid(previousXid));
diff --git a/src/backend/access/transam/transam.c b/src/backend/access/transam/transam.c
index 344b062886..fe9cafe9e3 100644
--- a/src/backend/access/transam/transam.c
+++ b/src/backend/access/transam/transam.c
@@ -158,8 +158,8 @@ TransactionIdDidCommit(TransactionId transactionId)
 		parentXid = SubTransGetParent(transactionId);
 		if (!TransactionIdIsValid(parentXid))
 		{
-			elog(WARNING, "no pg_subtrans entry for subcommitted XID %llu",
-				 (unsigned long long) transactionId);
+			elog(WARNING, "no pg_subtrans entry for subcommitted XID %" PRIu64,
+				 transactionId);
 			return false;
 		}
 		return TransactionIdDidCommit(parentXid);
@@ -213,8 +213,8 @@ TransactionIdDidAbort(TransactionId transactionId)
 		if (!TransactionIdIsValid(parentXid))
 		{
 			/* see notes in TransactionIdDidCommit */
-			elog(WARNING, "no pg_subtrans entry for subcommitted XID %llu",
-				 (unsigned long long) transactionId);
+			elog(WARNING, "no pg_subtrans entry for subcommitted XID %" PRIu64,
+				 transactionId);
 			return true;
 		}
 		return TransactionIdDidAbort(parentXid);
diff --git a/src/backend/access/transam/twophase.c b/src/backend/access/transam/twophase.c
index 84a34f740f..dc3bf0f4f1 100644
--- a/src/backend/access/transam/twophase.c
+++ b/src/backend/access/transam/twophase.c
@@ -832,8 +832,7 @@ TwoPhaseGetGXact(TransactionId xid, bool lock_held)
 		LWLockRelease(TwoPhaseStateLock);
 
 	if (result == NULL)			/* should not happen */
-		elog(ERROR, "failed to find GlobalTransaction for xid %llu",
-			 (unsigned long long) xid);
+		elog(ERROR, "failed to find GlobalTransaction for xid %" PRIu64, xid);
 
 	cached_xid = xid;
 	cached_gxact = result;
@@ -930,8 +929,7 @@ TwoPhaseGetDummyProc(TransactionId xid, bool lock_held)
 static inline int
 TwoPhaseFilePath(char *path, TransactionId xid)
 {
-	return snprintf(path, MAXPGPATH, TWOPHASE_DIR "/%016llX",
-					(unsigned long long) xid);
+	return snprintf(path, MAXPGPATH, TWOPHASE_DIR "/%016" PRIX64, xid);
 }
 
 /*
@@ -2083,8 +2081,8 @@ RecoverPreparedTransactions(void)
 			continue;
 
 		ereport(LOG,
-				(errmsg("recovering prepared transaction %llu from shared memory",
-						(unsigned long long) xid)));
+				(errmsg("recovering prepared transaction %" PRIu64 " from shared memory",
+						xid)));
 
 		hdr = (TwoPhaseFileHeader *) buf;
 		Assert(TransactionIdEquals(hdr->xid, xid));
@@ -2177,15 +2175,15 @@ ProcessTwoPhaseBuffer(TransactionId xid,
 		if (fromdisk)
 		{
 			ereport(WARNING,
-					(errmsg("removing stale two-phase state file for transaction %llu",
-							(unsigned long long) xid)));
+					(errmsg("removing stale two-phase state file for transaction %" PRIu64,
+							xid)));
 			RemoveTwoPhaseFile(xid, true);
 		}
 		else
 		{
 			ereport(WARNING,
-					(errmsg("removing stale two-phase state from memory for transaction %llu",
-							(unsigned long long) xid)));
+					(errmsg("removing stale two-phase state from memory for transaction %" PRIu64,
+							xid)));
 			PrepareRedoRemove(xid, true);
 		}
 		return NULL;
@@ -2197,15 +2195,15 @@ ProcessTwoPhaseBuffer(TransactionId xid,
 		if (fromdisk)
 		{
 			ereport(WARNING,
-					(errmsg("removing future two-phase state file for transaction %llu",
-							(unsigned long long) xid)));
+					(errmsg("removing future two-phase state file for transaction %" PRIu64,
+							xid)));
 			RemoveTwoPhaseFile(xid, true);
 		}
 		else
 		{
 			ereport(WARNING,
-					(errmsg("removing future two-phase state from memory for transaction %llu",
-							(unsigned long long) xid)));
+					(errmsg("removing future two-phase state from memory for transaction %" PRIu64,
+							xid)));
 			PrepareRedoRemove(xid, true);
 		}
 		return NULL;
@@ -2228,13 +2226,13 @@ ProcessTwoPhaseBuffer(TransactionId xid,
 		if (fromdisk)
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg("corrupted two-phase state file for transaction %llu",
-							(unsigned long long) xid)));
+					 errmsg("corrupted two-phase state file for transaction %" PRIu64,
+							xid)));
 		else
 			ereport(ERROR,
 					(errcode(ERRCODE_DATA_CORRUPTED),
-					 errmsg("corrupted two-phase state in memory for transaction %llu",
-							(unsigned long long) xid)));
+					 errmsg("corrupted two-phase state in memory for transaction %" PRIu64,
+							xid)));
 	}
 
 	/*
@@ -2395,8 +2393,8 @@ RecordTransactionAbortPrepared(TransactionId xid,
 	 * RecordTransactionCommitPrepared ...
 	 */
 	if (TransactionIdDidCommit(xid))
-		elog(PANIC, "cannot abort transaction %llu, it was already committed",
-			 (unsigned long long) xid);
+		elog(PANIC, "cannot abort transaction %" PRIu64 ", it was already committed",
+			 xid);
 
 	START_CRIT_SECTION();
 
@@ -2490,8 +2488,8 @@ PrepareRedoAdd(char *buf, XLogRecPtr start_lsn,
 		if (access(path, F_OK) == 0)
 		{
 			ereport(reachedConsistency ? ERROR : WARNING,
-					(errmsg("could not recover two-phase state file for transaction %llu",
-							(unsigned long long) hdr->xid),
+					(errmsg("could not recover two-phase state file for transaction %" PRIu64,
+							hdr->xid),
 					 errdetail("Two-phase state file has been found in WAL record %X/%X, but this transaction has already been restored from disk.",
 							   LSN_FORMAT_ARGS(start_lsn))));
 			return;
@@ -2535,8 +2533,8 @@ PrepareRedoAdd(char *buf, XLogRecPtr start_lsn,
 						   false /* backward */ , false /* WAL */ );
 	}
 
-	elog(DEBUG2, "added 2PC data in shared memory for transaction %llu",
-		 (unsigned long long) gxact->xid);
+	elog(DEBUG2, "added 2PC data in shared memory for transaction %" PRIu64,
+		 gxact->xid);
 }
 
 /*
@@ -2579,8 +2577,7 @@ PrepareRedoRemove(TransactionId xid, bool giveWarning)
 	/*
 	 * And now we can clean up any files we may have left.
 	 */
-	elog(DEBUG2, "removing 2PC data for transaction %llu",
-		 (unsigned long long) xid);
+	elog(DEBUG2, "removing 2PC data for transaction %" PRIu64, xid);
 	if (gxact->ondisk)
 		RemoveTwoPhaseFile(xid, giveWarning);
 	RemoveGXact(gxact);
@@ -2670,7 +2667,7 @@ TwoPhaseTransactionGid(Oid subid, TransactionId xid, char *gid_res, int szgid)
 				(errcode(ERRCODE_PROTOCOL_VIOLATION),
 				 errmsg_internal("invalid two-phase transaction ID")));
 
-	snprintf(gid_res, szgid, "pg_gid_%u_%llu", subid, (unsigned long long) xid);
+	snprintf(gid_res, szgid, "pg_gid_%u_%" PRIu64, subid, xid);
 }
 
 /*
@@ -2687,8 +2684,7 @@ IsTwoPhaseTransactionGidForSubid(Oid subid, char *gid)
 	char		gid_tmp[GIDSIZE];
 
 	/* Extract the subid and xid from the given GID */
-	ret = sscanf(gid, "pg_gid_%u_%llu", &subid_from_gid,
-				 (unsigned long long *) &xid_from_gid);
+	ret = sscanf(gid, "pg_gid_%u_%" PRIu64, &subid_from_gid, &xid_from_gid);
 
 	/*
 	 * Check that the given GID has expected format, and at least the subid
diff --git a/src/backend/access/transam/xact.c b/src/backend/access/transam/xact.c
index 83000402ea..e77d4a2130 100644
--- a/src/backend/access/transam/xact.c
+++ b/src/backend/access/transam/xact.c
@@ -1790,8 +1790,8 @@ RecordTransactionAbort(bool isSubXact)
 	 * Check that we haven't aborted halfway through RecordTransactionCommit.
 	 */
 	if (TransactionIdDidCommit(xid))
-		elog(PANIC, "cannot abort transaction %llu, it was already committed",
-			 (unsigned long long) xid);
+		elog(PANIC, "cannot abort transaction %" PRIu64 ", it was already committed",
+			 xid);
 
 	/*
 	 * Are we using the replication origins feature?  Or, in other words, are
@@ -5681,20 +5681,18 @@ ShowTransactionStateRec(const char *str, TransactionState s)
 	{
 		int			i;
 
-		appendStringInfo(&buf, ", children: %llu",
-						 (unsigned long long) s->childXids[0]);
+		appendStringInfo(&buf, ", children: %" PRIu64, s->childXids[0]);
 		for (i = 1; i < s->nChildXids; i++)
-			appendStringInfo(&buf, " %llu",
-							 (unsigned long long) s->childXids[i]);
+			appendStringInfo(&buf, " %" PRIu64, s->childXids[i]);
 	}
 	ereport(DEBUG5,
-			(errmsg_internal("%s(%d) name: %s; blockState: %s; state: %s, xid/subid/cid: %llu/%llu/%u%s%s",
+			(errmsg_internal("%s(%d) name: %s; blockState: %s; state: %s, xid/subid/cid: %" PRIu64 "/%" PRIu64 "/%u%s%s",
 							 str, s->nestingLevel,
 							 PointerIsValid(s->name) ? s->name : "unnamed",
 							 BlockStateAsString(s->blockState),
 							 TransStateAsString(s->state),
-							 (unsigned long long) XidFromFullTransactionId(s->fullTransactionId),
-							 (unsigned long long) s->subTransactionId,
+							 XidFromFullTransactionId(s->fullTransactionId),
+							 s->subTransactionId,
 							 (unsigned int) currentCommandId,
 							 currentCommandIdUsed ? " (used)" : "",
 							 buf.data)));
diff --git a/src/backend/access/transam/xlogrecovery.c b/src/backend/access/transam/xlogrecovery.c
index 23ea72cc93..e5fd0e8765 100644
--- a/src/backend/access/transam/xlogrecovery.c
+++ b/src/backend/access/transam/xlogrecovery.c
@@ -812,8 +812,8 @@ InitWalRecovery(ControlFileData *ControlFile, bool *wasShutdown_ptr,
 					(errmsg("entering standby mode")));
 		else if (recoveryTarget == RECOVERY_TARGET_XID)
 			ereport(LOG,
-					(errmsg("starting point-in-time recovery to XID %llu",
-							(unsigned long long) recoveryTargetXid)));
+					(errmsg("starting point-in-time recovery to XID %" PRIu64,
+							recoveryTargetXid)));
 		else if (recoveryTarget == RECOVERY_TARGET_TIME)
 			ereport(LOG,
 					(errmsg("starting point-in-time recovery to %s",
@@ -880,25 +880,25 @@ InitWalRecovery(ControlFileData *ControlFile, bool *wasShutdown_ptr,
 							 LSN_FORMAT_ARGS(checkPoint.redo),
 							 wasShutdown ? "true" : "false")));
 	ereport(DEBUG1,
-			(errmsg_internal("next transaction ID: %llu; next OID: %u",
-							 (unsigned long long) U64FromFullTransactionId(checkPoint.nextXid),
+			(errmsg_internal("next transaction ID: %" PRIu64 "; next OID: %u",
+							 U64FromFullTransactionId(checkPoint.nextXid),
 							 checkPoint.nextOid)));
 	ereport(DEBUG1,
-			(errmsg_internal("next MultiXactId: %llu; next MultiXactOffset: %llu",
-							 (unsigned long long) checkPoint.nextMulti,
-							 (unsigned long long) checkPoint.nextMultiOffset)));
+			(errmsg_internal("next MultiXactId: %" PRIu64 "; next MultiXactOffset: %" PRIu64,
+							 checkPoint.nextMulti,
+							 checkPoint.nextMultiOffset)));
 	ereport(DEBUG1,
-			(errmsg_internal("oldest unfrozen transaction ID: %llu, in database %u",
-							 (unsigned long long) checkPoint.oldestXid,
+			(errmsg_internal("oldest unfrozen transaction ID: %" PRIu64 ", in database %u",
+							 checkPoint.oldestXid,
 							 checkPoint.oldestXidDB)));
 	ereport(DEBUG1,
-			(errmsg_internal("oldest MultiXactId: %llu, in database %u",
-							 (unsigned long long) checkPoint.oldestMulti,
+			(errmsg_internal("oldest MultiXactId: %" PRIu64 ", in database %u",
+							 checkPoint.oldestMulti,
 							 checkPoint.oldestMultiDB)));
 	ereport(DEBUG1,
-			(errmsg_internal("commit timestamp Xid oldest/newest: %llu/%llu",
-							 (unsigned long long) checkPoint.oldestCommitTsXid,
-							 (unsigned long long) checkPoint.newestCommitTsXid)));
+			(errmsg_internal("commit timestamp Xid oldest/newest: %" PRIu64 "/%" PRIu64,
+							 checkPoint.oldestCommitTsXid,
+							 checkPoint.newestCommitTsXid)));
 	if (!TransactionIdIsNormal(XidFromFullTransactionId(checkPoint.nextXid)))
 		ereport(PANIC,
 				(errmsg("invalid next transaction ID")));
@@ -2714,15 +2714,15 @@ recoveryStopsBefore(XLogReaderState *record)
 		if (isCommit)
 		{
 			ereport(LOG,
-					(errmsg("recovery stopping before commit of transaction %llu, time %s",
-							(unsigned long long) recoveryStopXid,
+					(errmsg("recovery stopping before commit of transaction %" PRIu64 ", time %s",
+							recoveryStopXid,
 							timestamptz_to_str(recoveryStopTime))));
 		}
 		else
 		{
 			ereport(LOG,
-					(errmsg("recovery stopping before abort of transaction %llu, time %s",
-							(unsigned long long) recoveryStopXid,
+					(errmsg("recovery stopping before abort of transaction %" PRIu64 ", time %s",
+							recoveryStopXid,
 							timestamptz_to_str(recoveryStopTime))));
 		}
 	}
@@ -2859,16 +2859,16 @@ recoveryStopsAfter(XLogReaderState *record)
 				xact_info == XLOG_XACT_COMMIT_PREPARED)
 			{
 				ereport(LOG,
-						(errmsg("recovery stopping after commit of transaction %llu, time %s",
-								(unsigned long long) recoveryStopXid,
+						(errmsg("recovery stopping after commit of transaction %" PRIu64 ", time %s",
+								recoveryStopXid,
 								timestamptz_to_str(recoveryStopTime))));
 			}
 			else if (xact_info == XLOG_XACT_ABORT ||
 					 xact_info == XLOG_XACT_ABORT_PREPARED)
 			{
 				ereport(LOG,
-						(errmsg("recovery stopping after abort of transaction %llu, time %s",
-								(unsigned long long) recoveryStopXid,
+						(errmsg("recovery stopping after abort of transaction %" PRIu64 ", time %s",
+								recoveryStopXid,
 								timestamptz_to_str(recoveryStopTime))));
 			}
 			return true;
@@ -2903,9 +2903,9 @@ getRecoveryStopReason(void)
 
 	if (recoveryTarget == RECOVERY_TARGET_XID)
 		snprintf(reason, sizeof(reason),
-				 "%s transaction %llu",
+				 "%s transaction %" PRIu64,
 				 recoveryStopAfter ? "after" : "before",
-				 (unsigned long long) recoveryStopXid);
+				 recoveryStopXid);
 	else if (recoveryTarget == RECOVERY_TARGET_TIME)
 		snprintf(reason, sizeof(reason),
 				 "%s %s\n",
diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index dfedb08c81..f91f031fa6 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -1583,16 +1583,14 @@ vac_update_relstats(Relation relation,
 	if (futurexid)
 		ereport(WARNING,
 				(errcode(ERRCODE_DATA_CORRUPTED),
-				 errmsg_internal("overwrote invalid relfrozenxid value %llu with new value %llu for table \"%s\"",
-								 (unsigned long long) oldfrozenxid,
-								 (unsigned long long) frozenxid,
+				 errmsg_internal("overwrote invalid relfrozenxid value %" PRIu64 " with new value %" PRIu64 " for table \"%s\"",
+								 oldfrozenxid, frozenxid,
 								 RelationGetRelationName(relation))));
 	if (futuremxid)
 		ereport(WARNING,
 				(errcode(ERRCODE_DATA_CORRUPTED),
-				 errmsg_internal("overwrote invalid relminmxid value %llu with new value %llu for table \"%s\"",
-								 (unsigned long long) oldminmulti,
-								 (unsigned long long) minmulti,
+				 errmsg_internal("overwrote invalid relminmxid value %" PRIu64 " with new value %" PRIu64 " for table \"%s\"",
+								 oldminmulti, minmulti,
 								 RelationGetRelationName(relation))));
 }
 
diff --git a/src/backend/nodes/outfuncs.c b/src/backend/nodes/outfuncs.c
index 896ae18a74..1e0fb7e9cd 100644
--- a/src/backend/nodes/outfuncs.c
+++ b/src/backend/nodes/outfuncs.c
@@ -309,7 +309,7 @@ _outList(StringInfo str, const List *node)
 		else if (IsA(node, OidList))
 			appendStringInfo(str, " %u", lfirst_oid(lc));
 		else if (IsA(node, XidList))
-			appendStringInfo(str, " %llu", (unsigned long long) lfirst_xid(lc));
+			appendStringInfo(str, " %" PRIu64, lfirst_xid(lc));
 		else
 			elog(ERROR, "unrecognized list node type: %d",
 				 (int) node->type);
